#include <stdio.h>

char f[80][80];
char l[80][80];
int w,h;

void mprint()
{
	int i,j;
	
	printf("+");
	for(i=0;i<w;i++) printf("-");
	printf("+\n");
	for(j=1;j<=h;j++)
	{
		printf("|");
		for(i=1;i<=w;i++)
			switch(f[i][j])
			{
				case 0:printf(" ");break;
				case 1:printf("o");break;
				case 2:printf("|");break;
				case 4:printf("-");break;
				case 8:printf("/");break;
				case 16:printf("\\");break;
				case 32:printf("%c",l[i][j]);break;
				case 6:printf("+");break;	
				case 24:printf("x");break;
				default:printf("*");
			}
		printf("|\n");
	}
	printf("+");
	for(i=0;i<w;i++) printf("-");
	printf("+\n\n");
}

#define SORT(a,b) (((a)>(b))?((a)^=(b)^=(a)^=(b)):0)
#define SWAP(a,b) ((a)^=(b)^=(a)^=(b));

void mclear(int x1,int y1,int x2,int y2)
{
	int i,j;
	SORT(x1,x2);
	SORT(y1,y2);
	for(i=x1;i<=x2;i++)
		for(j=y1;j<=y2;j++) f[i][j]=0;
}

void mline(int x1,int y1,int x2,int y2)
{
	int i;
	if((x1>x2)) {SWAP(x1,x2);SWAP(y1,y2);}
	if(x1==x2)
	{
		SORT(y1,y2);
		for(i=y1;i<=y2;i++) f[x1][i]|=2;
		return;
	}
	if(y1==y2)
	{
		SORT(x1,x2);
		for(i=x1;i<=x2;i++) f[i][y1]|=4;
		return;
	}
	if(y1<y2)
	{
		for(i=x1;i<=x2;i++)
			f[i][y1+i-x1]|=16;
		return;
	}
	for(i=x1;i<=x2;i++)
		f[i][y1-(i-x1)]|=8;

}

void mtext(int x,int y,char *s)
{
	int i;
	for(i=0;(s[i])&&(x+i<=w);i++)
	{
		if(f[i+x][y]&32)
		{
			if(l[i+x][y]!=s[i])
				f[i+x][y]=64;
		}
		else{l[i+x][y]=s[i];f[i+x][y]|=32;}
	}
}

int main()
{
	int go,x1,y1,x2,y2;
	char s[200],s2[200];
	
	scanf("%d %d",&w,&h);
	while(w!=0)
	{
		go=1;
		mclear(1,1,w,h);
		while(go)
		{
			gets(s);
			switch(s[0])
			{
				case 'L':sscanf(s+4,"%d %d %d %d",&x1,&y1,&x2,&y2);
					 mline(x1,y1,x2,y2);
					 break;
				case 'C':sscanf(s+5,"%d %d %d %d",&x1,&y1,&x2,&y2);
					 mclear(x1,y1,x2,y2);
					 break;
				case 'T':sscanf(s+4,"%d %d %s",&x1,&y1,s2);
					 mtext(x1,y1,s2);
					 break;
				case 'P':if(s[1]=='R'){mprint(); go=0;}
					 else{sscanf(s+5,"%d %d",&x1,&y1);f[x1][y1]|=1;}
					 break;
/*				default:printf("E:%s\n",s);*/
			}
/*			mprint();*/
		}
		scanf("%d %d",&w,&h);
	}
	return 0;
}
